/*
 * This file is part of libdatagen-base, licensed under the MIT License
 *
 * Copyright (c) 2021-2022 Garden of Fancy (dev@gofancy.wtf)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package wtf.gofancy.libdatagen.base.resource

import okio.ByteString
import okio.ByteString.Companion.encodeUtf8
import wtf.gofancy.libdatagen.base.Generator
import kotlin.jvm.Throws

/**
 * A resource describes the content of a file which should get generated by a [Generator].
 *
 * The only provided implementation of this resource by ourselves is [SerializationResource] because it should cover all
 * needs. Though others may create their own implementations.
 *
 * @see SerializationResource
 */
fun interface Resource {

    /**
     * The bytes to be used for the generated files content.
     *
     * ### API Note
     *
     * The reason we use bytes to store the files content is to ensure compatibility across all kinds
     * of file formats. For text based files consider using [String.encodeUtf8][okio.ByteString.Companion.encodeUtf8].
     *
     * @return The content of the generated file as bytes.
     * @throws ByteEncodingException if the resource encountered an unrecoverable error while trying to convert an
     * object into bytes. Generators catch this exception to mark a resource as failed and skip it.
     */
    @Throws(ByteEncodingException::class)
    fun bytes(): ByteString
}
